package com.virtual.plat.server.organize;

import com.extjs.gxt.ui.client.data.ModelData;
import com.virtual.common.AppException;
import com.virtual.common.ErrorCodes;
import com.virtual.common.FuncUtil;
import com.virtual.common.StringManager;
import com.virtual.plat.server.MailProcessor;
import com.virtual.plat.server.controller.entity.ResourcePoolPo;
import com.virtual.plat.server.entity.Cluster;
import com.virtual.plat.server.entity.Domain;
import com.virtual.plat.server.entity.Hostpool;
import com.virtual.plat.server.entity.Operator;
import com.virtual.plat.server.entity.OrgOperator;
import com.virtual.plat.server.entity.PublicCloud;
import com.virtual.plat.server.entity.QueryConfig;
import com.virtual.plat.server.entity.QueryResult;
import com.virtual.plat.server.entity.ResourcePool;
import com.virtual.plat.server.entity.User;
import com.virtual.plat.server.entity.UserVm;
import com.virtual.plat.server.entity.VmWorkflow;
import com.virtual.plat.server.http.pool.HttpConnectionManager;
import com.virtual.plat.server.mail.MailMessage;
import com.virtual.plat.server.mail.MailSenderMgr;
import com.virtual.plat.server.operator.OperatorDao;
import com.virtual.plat.server.organize.OrganizationMgr;
import com.virtual.plat.server.publiccloud.PublicCloudMgr;
import com.virtual.plat.server.rs.entity.RsCommList;
import com.virtual.plat.server.rs.vm.entity.RsDomain;
import com.virtual.plat.server.sms.SmsMgr;
import com.virtual.plat.server.user.UserMgr;
import com.virtual.plat.server.virtualhost.DomainHandler;
import com.virtual.plat.server.virtualhost.DomainMgr;
import com.virtual.plat.server.virtualhost.DomainUtils;
import com.virtual.plat.server.vmworkflow.VmWorkflowMgr;
import java.net.URI;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import org.apache.commons.lang.StringUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.http.HttpHost;
import org.apache.http.HttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.utils.URIUtils;
import org.apache.http.client.utils.URLEncodedUtils;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;
import org.springframework.stereotype.Service;

@Service("organizationUtils")
public class OrganizationUtils {

   private static Log log = LogFactory.getLog(OrganizationUtils.class);
   private static StringManager sm = StringManager.getManager(OrganizationUtils.class);
   private static StringManager domainsm = StringManager.getManager(DomainHandler.class);


   public Long addHostpool(Hostpool var1) {
      return null;
   }

   public Long addCluster(Cluster var1) {
      return null;
   }

   public Long addDomain(Domain var1) {
      return null;
   }

   public static List sendEmailToOrgOperator(List var0, OperatorDao var1, MailProcessor var2, String var3, int var4, String var5) {
      ArrayList var6 = new ArrayList();
      if(var0 != null) {
         String var7 = "";
         if(var4 == 0) {
            var7 = sm.getString("mail.login.subject");
         } else if(var4 == 1) {
            var7 = sm.getString("mail.vmworkflow.apply.subject", new Object[]{var5});
         } else if(var4 == 2) {
            var7 = sm.getString("mail.vmworkflow.cancel.subject", new Object[]{var5});
         } else if(var4 == 3) {
            var7 = sm.getString("mail.clouddisk.apply.subject", new Object[]{var5});
         } else if(var4 == 4) {
            var7 = sm.getString("mail.clouddisk.delay.subject", new Object[]{var5});
         }

         ArrayList var8 = new ArrayList();
         Iterator var15 = var0.iterator();

         QueryResult var17;
         while(var15.hasNext()) {
            OrgOperator var9;
            if((var9 = (OrgOperator)var15.next()).getOperatorId() != null) {
               var8.add(var9.getOperatorId());
            } else if(var9.getOpGroupId() != null) {
               QueryConfig var10;
               (var10 = new QueryConfig()).addRestriction("operatorGroups.id", var9.getOpGroupId());
               if((var17 = var1.readByCondition(var10)) != null && var17.getData() != null) {
                  Iterator var11 = var17.getData().iterator();

                  while(var11.hasNext()) {
                     Operator var12;
                     if(!StringUtils.isEmpty((var12 = (Operator)var11.next()).getEmail())) {
                        try {
                           String var18 = "";
                           if(var4 == 0) {
                              var18 = sm.getString("mail.login.message", new Object[]{var12.getUserName(), var3, var12.getLoginName()});
                           } else if(var4 == 1) {
                              var18 = sm.getString("mail.vmworkflow.apply.message", new Object[]{var12.getUserName(), var5});
                           } else if(var4 == 2) {
                              var18 = sm.getString("mail.vmworkflow.cancel.message", new Object[]{var12.getUserName(), var5});
                           } else if(var4 == 3) {
                              var18 = sm.getString("mail.clouddisk.apply.message", new Object[]{var12.getUserName(), var5});
                           } else if(var4 == 4) {
                              var18 = sm.getString("mail.clouddisk.delay.message", new Object[]{var12.getUserName(), var5});
                           }

                           MailMessage var19;
                           (var19 = new MailMessage()).addTo(var12.getEmail());
                           var19.setSubject(var7);
                           var19.setMessage(var18);
                           var2.postRequest(var19);
                        } catch (AppException var14) {
                           log.error(var14);
                           var6.add(var12.getLoginName());
                        }
                     }
                  }
               }
            }
         }

         if(var8.size() != 0) {
            QueryConfig var16;
            (var16 = new QueryConfig()).addRestriction("id_in", var8);
            if((var17 = var1.readByCondition(var16)) != null && var17.getData() != null) {
               Iterator var20 = var17.getData().iterator();

               while(var20.hasNext()) {
                  Operator var22;
                  if(!StringUtils.isEmpty((var22 = (Operator)var20.next()).getEmail())) {
                     try {
                        String var21 = "";
                        if(var4 == 0) {
                           var21 = sm.getString("mail.login.message", new Object[]{var22.getUserName(), var3, var22.getLoginName()});
                        } else if(var4 == 1) {
                           var21 = sm.getString("mail.vmworkflow.apply.message", new Object[]{var22.getUserName(), var5});
                        } else if(var4 == 2) {
                           var21 = sm.getString("mail.vmworkflow.cancel.message", new Object[]{var22.getUserName(), var5});
                        } else if(var4 == 3) {
                           var21 = sm.getString("mail.clouddisk.apply.message", new Object[]{var22.getUserName(), var5});
                        } else if(var4 == 4) {
                           var21 = sm.getString("mail.clouddisk.delay.message", new Object[]{var22.getUserName(), var5});
                        }

                        MailMessage var23;
                        (var23 = new MailMessage()).addTo(var22.getEmail());
                        var23.setSubject(var7);
                        var23.setMessage(var21);
                        var2.postRequest(var23);
                     } catch (AppException var13) {
                        log.error(var13);
                        var6.add(var22.getLoginName());
                     }
                  }
               }
            }
         }
      }

      return var6;
   }

   public static List queryAllRunningVmByClusterId(PublicCloud var0, ModelData var1, HttpConnectionManager var2) {
      String var11 = (String)var1.get("clusterIds");
      ArrayList var3 = new ArrayList();
      DefaultHttpClient var4 = null;
      var11 = "/cas/casrs/cluster/runVm?clusterIds=" + var11;
      HttpGet var12;
      (var12 = new HttpGet(var11)).addHeader("accept", "application/xml");

      try {
         HttpResponse var5 = (var4 = var2.getConnection(var0.getProtocal(), var0.getUri(), var0.getPort().intValue(), var0.getUserName(), var0.getPassword())).execute(var12);
         String var13;
         RsCommList var14;
         if(200 == var5.getStatusLine().getStatusCode() && StringUtils.isNotEmpty(var13 = EntityUtils.toString(var5.getEntity(), "UTF-8")) && (var14 = (RsCommList)FuncUtil.convertXmlToObject(var13.trim(), RsCommList.class)) != null && var14.getData() != null && var14.getData().size() > 0) {
            Iterator var15 = var14.getData().iterator();

            while(var15.hasNext()) {
               RsDomain var6 = (RsDomain)var15.next();
               var3.add(var6.getId());
            }
         }
      } catch (Exception var9) {
         log.error((Object)null, var9);
      } finally {
         var12.abort();
         var2.releaseConnection(var0.getProtocal(), var0.getUri(), var0.getPort().intValue(), var0.getUserName(), var4);
      }

      return var3;
   }

   public static PublicCloud getPublicCloudById(Long var0, PublicCloudMgr var1) {
      if(var0 != null) {
         return var1.queryPublicCloudById(var0);
      } else {
         throw new AppException(9007);
      }
   }

   public static List queryStorageRes(PublicCloud var0, ModelData var1, HttpConnectionManager var2) {
      String var3 = (String)var1.get("clusterId");
      return queryStorageRes(var0, var3, var2, 1);
   }

   public static List queryStorageRes(PublicCloud var0, String var1, HttpConnectionManager var2, int var3) {
      Object var4 = new ArrayList();
      DefaultHttpClient var5 = null;
      HttpGet var6 = null;
      boolean var11 = false;

      try {
         var11 = true;
         HttpHost var7;
         if((var7 = (HttpHost)(var5 = var2.getConnection(var0.getProtocal(), var0.getUri(), var0.getPort().intValue(), var0.getUserName(), var0.getPassword())).getParams().getParameter("http.default-host")) == null) {
            throw new AppException(1005, ErrorCodes.getErrorMessage(1005));
         }

         ArrayList var8;
         (var8 = new ArrayList()).add(new BasicNameValuePair("clusterIds", var1));
         var8.add(new BasicNameValuePair("isFsControlOper", Integer.toString(var3)));
         URI var14 = URIUtils.createURI(var7.getSchemeName(), var7.getHostName(), var7.getPort(), "/cas/casrs/cluster/storageRes", URLEncodedUtils.format(var8, "UTF-8"), (String)null);
         (var6 = new HttpGet(var14)).addHeader("accept", "application/xml");
         HttpResponse var15 = var5.execute(var6);
         if(200 == var15.getStatusLine().getStatusCode()) {
            if(StringUtils.isNotEmpty(var1 = EntityUtils.toString(var15.getEntity(), "UTF-8"))) {
               var4 = ((RsCommList)FuncUtil.convertXmlToObject(var1.trim(), RsCommList.class)).getData();
               var11 = false;
            } else {
               var11 = false;
            }
         } else {
            var11 = false;
         }
      } catch (Exception var12) {
         log.error((Object)null, var12);
         throw new AppException(9101);
      } finally {
         if(var11) {
            if(var6 != null) {
               var6.abort();
            }

            var2.releaseConnection(var0.getProtocal(), var0.getUri(), var0.getPort().intValue(), var0.getUserName(), var5);
         }
      }

      var6.abort();
      var2.releaseConnection(var0.getProtocal(), var0.getUri(), var0.getPort().intValue(), var0.getUserName(), var5);
      return (List)var4;
   }

   public static List queryTopNRate(PublicCloud var0, ModelData var1, HttpConnectionManager var2, DomainMgr var3) {
      String var4 = (String)var1.get("type");
      String var10 = DomainUtils.getUniqueKeyListByIds((List)var1.get("idList"), var3);
      Object var12 = new ArrayList();
      DefaultHttpClient var5 = null;
      var10 = "/cas/casrs/cluster/topNRate/" + var4 + "?vmIds=" + var10;
      HttpGet var11;
      (var11 = new HttpGet(var10)).addHeader("accept", "application/xml");

      try {
         HttpResponse var13 = (var5 = var2.getConnection(var0.getProtocal(), var0.getUri(), var0.getPort().intValue(), var0.getUserName(), var0.getPassword())).execute(var11);
         if(200 == var13.getStatusLine().getStatusCode() && StringUtils.isNotEmpty(var4 = EntityUtils.toString(var13.getEntity(), "UTF-8"))) {
            var12 = ((RsCommList)FuncUtil.convertXmlToObject(var4.trim(), RsCommList.class)).getData();
         }
      } catch (Exception var8) {
         log.error((Object)null, var8);
      } finally {
         var11.abort();
         var2.releaseConnection(var0.getProtocal(), var0.getUri(), var0.getPort().intValue(), var0.getUserName(), var5);
      }

      return (List)var12;
   }

   public static List queryTopNThrend(PublicCloud var0, ModelData var1, HttpConnectionManager var2, DomainMgr var3) {
      String var4 = (String)var1.get("type");
      List var5 = (List)var1.get("idList");
      Integer var11 = (Integer)var1.get("interval");
      String var13 = DomainUtils.getUniqueKeyListByIds(var5, var3);
      Object var15 = new ArrayList();
      DefaultHttpClient var6 = null;
      var13 = "/cas/casrs/cluster/topNThrend/" + var4 + "?vmIds=" + var13;
      if(var11 != null) {
         var13 = var13 + "&interval=" + var11;
      }

      HttpGet var12;
      (var12 = new HttpGet(var13)).addHeader("accept", "application/xml");

      try {
         HttpResponse var14 = (var6 = var2.getConnection(var0.getProtocal(), var0.getUri(), var0.getPort().intValue(), var0.getUserName(), var0.getPassword())).execute(var12);
         if(200 == var14.getStatusLine().getStatusCode() && StringUtils.isNotEmpty(var13 = EntityUtils.toString(var14.getEntity(), "UTF-8"))) {
            var15 = ((RsCommList)FuncUtil.convertXmlToObject(var13.trim(), RsCommList.class)).getData();
         }
      } catch (Exception var9) {
         log.error((Object)null, var9);
      } finally {
         var12.abort();
         var2.releaseConnection(var0.getProtocal(), var0.getUri(), var0.getPort().intValue(), var0.getUserName(), var6);
      }

      return (List)var15;
   }

   public static void distributionOrgInfo(ModelData var0, OrganizationMgr var1, VmWorkflowMgr var2, UserMgr var3, MailSenderMgr var4, SmsMgr var5) {
      Long var6;
      if((var6 = (Long)var0.get("domainId")) != null) {
         Long var7 = (Long)var0.get("desktopPoolId");
         Long var8 = (Long)var0.get("orgId");
         Long var9 = (Long)var0.get("cloudId");
         List var10 = (List)var0.get("userIds");
         List var11 = (List)var0.get("userGrpIds");
         Long var12 = (Long)var0.get("resourcePoolId");
         Date var13 = (Date)var0.get("expireDate");
         String var14 = (String)var0.get("uniqueKey");
         Iterator var15;
         Long var16;
         UserVm var17;
         if(var10 != null) {
            var15 = var10.iterator();

            while(var15.hasNext()) {
               var16 = (Long)var15.next();
               (var17 = new UserVm()).setFlag(Integer.valueOf(1));
               var17.setOrgId(var8);
               var17.setDomainId(var6);
               var17.setTitle((String)var0.get("title"));
               var17.setUserId(var16);
               var17.setDesktopPoolId(var7);
               var17.setExpireDate(var13);
               var17.setPublicCloudId(var9);
               var17.setResPoolId(var12.longValue());
               var17.setUniqueKey(var14);
               var1.addOrgUserVm(var17);
            }
         }

         if(var11 != null) {
            var15 = var11.iterator();

            while(var15.hasNext()) {
               var16 = (Long)var15.next();
               (var17 = new UserVm()).setFlag(Integer.valueOf(2));
               var17.setOrgId(var8);
               var17.setDomainId(var6);
               var17.setTitle((String)var0.get("title"));
               var17.setUserGrpId(var16);
               var17.setDesktopPoolId(var7);
               var17.setPublicCloudId(var9);
               var17.setResPoolId(var12.longValue());
               var17.setUniqueKey(var14);
               var1.addOrgUserVm(var17);
            }
         }

         if(var10 == null && var11 == null) {
            UserVm var23;
            (var23 = new UserVm()).setOrgId(var8);
            var23.setFlag(Integer.valueOf(0));
            var23.setDomainId(var6);
            var23.setTitle((String)var0.get("title"));
            var23.setDesktopPoolId(var7);
            var23.setPublicCloudId(var9);
            var23.setResPoolId(var12.longValue());
            var23.setUniqueKey(var14);
            var1.addOrgUserVm(var23);
         }

         Long var24;
         if((var24 = (Long)var0.get("workFlowId")) != null) {
            String var25 = null;
            User var26 = null;

            String var21;
            try {
               VmWorkflow var20;
               (var20 = var2.queryVmWorkflowById(var24)).setStatus(Integer.valueOf(11));
               var2.updateVmWorkflow(var20);
               var26 = var3.queryUserById(var20.getUserId());
               var21 = var20.getTitle() == null?var20.getDomainName():var20.getTitle();
               String var22 = domainsm.getString("mail.vm.subject");
               var25 = domainsm.getString("mail.vm.no.sysconfig.message", new Object[]{var26.getLoginName(), var21});
               var4.sendMail(var26.getEmail(), var22, var25);
            } catch (AppException var18) {
               log.error((Object)null, var18);
            }

            if(var26 != null && StringUtils.isNotBlank(var26.getPhone()) && StringUtils.isNotBlank(var25)) {
               try {
                  if((var21 = (String)var5.readSmsConfig().get("smsBusinessView")) != null && var21.contains("1")) {
                     var5.sendSms(var26.getPhone(), var25);
                  }

                  return;
               } catch (Exception var19) {
                  log.error((Object)null, var19);
               }
            }
         }

      }
   }

   public static List transToResourcePoolPo(List var0) {
      ArrayList var1 = new ArrayList();
      Iterator var4 = var0.iterator();

      while(var4.hasNext()) {
         ResourcePool var2 = (ResourcePool)var4.next();
         ResourcePoolPo var3;
         (var3 = new ResourcePoolPo()).setId(var2.getId());
         var3.setCloudId(var2.getCloudId());
         var3.setName(var2.getName());
         var3.setDescription(var2.getDescription());
         var3.setCloudType(Integer.valueOf(var2.getCloudType()));
         var1.add(var3);
      }

      return var1;
   }

}
